【问题描述】 46.全排列 (中等)
给定一个 没有重复 数字的序列,返回其所有可能的全排列。示例:输入: [1,2,3]
输出:
[[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]
]
【解答思路】
1. 回溯
时间复杂度:O(NN!) 空间复杂度:O(NN!)
public class Solution {public List<List<Integer>> permute(int[] nums) {// 首先是特判int len = nums.length;// 使用一个动态数组保存所有可能的全排列List<List<Integer>> res = new ArrayList<>();if (len == 0) {return res;}boolean[] used = new boolean[len];List<Integer> path = new ArrayList<>();dfs(nums, len, 0, path, used, res);return res;}private void dfs(int[] nums, int len, int depth,List<Integer> path, boolean[] used,List<List<Integer>> res) {if (depth == len) {
//不能直接path
//path 这个变量所指向的对象在递归的过程中只有一份,深度优先遍历完成以后,因为回到了根结点(因为我们之前说了,从深层结点回到浅层结点的时候,需要撤销之前的选择),因此 path 这个变量回到根结点以后都为空。res.add(new ArrayList<>(path));return;}
//contains时间复杂度更高//if (path.contains(nums[i])) {
// continue;
// }for (int i = 0; i < len; i++) {if (!used[i]) {path.add(nums[i]);used[i] = true;dfs(nums, len, depth + 1, path, used, res);// 注意:这里是状态重置,是从深层结点回到浅层结点的过程,代码在形式上和递归之前是对称的used[i] = false;path.remove(path.size() - 1);}}}public static void main(String[] args) {int[] nums = {1, 2, 3};Solution solution = new Solution();List<List<Integer>> lists = solution.permute(nums);System.out.println(lists);}
}作者:liweiwei1419
链接:https://leetcode-cn.com/problems/permutations/solution/hui-su-suan-fa-python-dai-ma-java-dai-ma-by-liweiw/
创建新的变量 不回溯
import java.util.ArrayList;
import java.util.List;public class Solution {public List<List<Integer>> permute(int[] nums) {// 首先是特判int len = nums.length;// 使用一个动态数组保存所有可能的全排列List<List<Integer>> res = new ArrayList<>();if (len == 0) {return res;}boolean[] used = new boolean[len];List<Integer> path = new ArrayList<>();dfs(nums, len, 0, path, used, res);return res;}private void dfs(int[] nums, int len, int depth,List<Integer> path, boolean[] used,List<List<Integer>> res) {if (depth == len) {// 3、不用拷贝,因为每一层传递下来的 path 变量都是新建的res.add(path);return;}for (int i = 0; i < len; i++) {if (!used[i]) {// 1、每一次尝试都创建新的变量表示当前的"状态"List<Integer> newPath = new ArrayList<>(path);newPath.add(nums[i]);boolean[] newUsed = new boolean[len];System.arraycopy(used, 0, newUsed, 0, len);newUsed[i] = true;dfs(nums, len, depth + 1, newPath, newUsed, res);// 2、无需回溯}}}
}
另一种写法
List<List<Integer>> res = new LinkedList<>();/* 主函数,输入一组不重复的数字,返回它们的全排列 */
List<List<Integer>> permute(int[] nums) {// 记录「路径」LinkedList<Integer> track = new LinkedList<>();backtrack(nums, track);return res;
}// 路径:记录在 track 中
// 选择列表:nums 中不存在于 track 的那些元素
// 结束条件:nums 中的元素全都在 track 中出现
void backtrack(int[] nums, LinkedList<Integer> track) {// 触发结束条件if (track.size() == nums.length) {res.add(new LinkedList(track));return;}for (int i = 0; i < nums.length; i++) {// 排除不合法的选择if (track.contains(nums[i]))continue;// 做选择track.add(nums[i]);// 进入下一层决策树backtrack(nums, track);// 取消选择track.removeLast();}
}作者:labuladong
链接:https://leetcode-cn.com/problems/permutations/solution/hui-su-suan-fa-xiang-jie-by-labuladong-2/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
【总结】
1.回溯算法总结
「回溯算法」是在一个「树形问题」上的「深度优先遍历」,是「深度优先遍历」在搜索问题上的另一种叫法。
- 调只使用一份「状态」变量去搜索整个状态空间,在状态空间很大的时候,这种做法是节约空间的,并且在一定程度上也是节约时间的。
-在不满足条件的时候(或者是找到了一个解以后),会回到之前的结点,以搜索更多的解,所以有「回溯」的需求。
2.为什么使用深度优先遍历?
(1)首先是正确性,只有遍历状态空间,才能得到所有符合条件的解;
(2)在深度优先遍历的时候,不同状态之间的切换很容易,可以再看一下上面有很多箭头的那张图,每两个状态之间的差别只有 1 处,因此回退非常方便,这样全局才能使用一份状态变量完成搜索;
(3)如果使用广度优先遍历,从浅层转到深层,状态的变化就很大,此时我们不得不在每一个状态都新建变量去保存它,从性能来说是不划算的;
(4)如果使用广度优先遍历就得使用队列,然后编写结点类。使用深度优先遍历,我们是直接使用了系统栈,系统栈帮助我们保存了每一个结点的状态信息。于是我们不用编写结点类,不必手动编写栈完成深度优先遍历。
3.回溯算法tips
- 回溯算法会大量应用“剪枝”技巧达到以加快搜索速度。有些时候,需要做一些预处理工作(例如排序)才能达到剪枝的目的。
- 预处理工作虽然也消耗时间,但一般而且能够剪枝节约的时间更多。还有正是因为回溯问题本身时间复杂度就很高,所以能用空间换时间就尽量使用空间。否则时间消耗又上去了。
- 先画图,画图是非常重要的,只有画图才能帮助我们想清楚递归结构,想清楚如何剪枝。
4.对代码的思考
5.回溯法模板
if 满足结束条件:result.add(路径)return
for 选择 in 选择列表:#排除不合法的选择d将该选择从选择列表移除(used数组 /条件限制)# 做选择路径.add(选择)backtrack(路径, 选择列表)# 撤销选择路径.remove(选择)
作者链接:https://leetcode-cn.com/problems/permutations/solution/hui-su-suan-fa-python-dai-ma-java-dai-ma-by-liweiw/